package org.processmining.acceptingpetrinet.connections;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
import org.processmining.acceptingpetrinet.parameters.MergeAcceptingPetriNetArrayIntoAcceptingPetriNetParameters;
import org.processmining.framework.connections.impl.AbstractConnection;

public class MergeAcceptingPetriNetArrayIntoAcceptingPetriNetConnection extends AbstractConnection {

	public final static String NETS = "Nets";
	public final static String NET = "Net";

	private MergeAcceptingPetriNetArrayIntoAcceptingPetriNetParameters parameters;

	public MergeAcceptingPetriNetArrayIntoAcceptingPetriNetConnection(AcceptingPetriNetArray nets,
			AcceptingPetriNet net, MergeAcceptingPetriNetArrayIntoAcceptingPetriNetParameters parameters) {
		super("Merge Accepting Petri Net Array Into Accepting Petri Net Connection");
		put(NETS, nets);
		put(NET, net);
		this.parameters = new MergeAcceptingPetriNetArrayIntoAcceptingPetriNetParameters(parameters);
	}

	public MergeAcceptingPetriNetArrayIntoAcceptingPetriNetParameters getParameters() {
		return parameters;
	}
}
