package org.processmining.acceptingpetrinet.plugins;

import java.io.InputStream;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetFactory;
import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;

@Plugin(name = "Import Accepting Petri Net from PNML file", level = PluginLevel.Regular, parameterLabels = { "Filename" }, returnLabels = { "Accepting Petri Net" }, returnTypes = { AcceptingPetriNet.class })
@UIImportPlugin(description = "PNML Accepting Petri Net files", extensions = { "pnml", "apnml" })
public class ImportAcceptingPetriNetPlugin extends AbstractImportPlugin {

	protected FileFilter getFileFilter() {
		return new FileNameExtensionFilter("PNML files", "pnml", "apnml");
	}

	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		AcceptingPetriNet net = AcceptingPetriNetFactory.createAcceptingPetriNet();
		net.importFromStream(context, input);
		return net;
	}
}
