/**
 * 
 */
package org.processmining.plugins.cnet;

import java.awt.Color;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.cnet.CNet;
import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.ViewSpecificAttributeMap;
import org.processmining.models.jgraph.ProMJGraphVisualizer;
import org.processmining.models.visualcnet.CNetV;
import org.processmining.models.visualcnet.CNetVNode;

/**
 * @author aadrians
 * Oct 7, 2011
 *
 */
@Plugin(name = "Visualize CNet", returnLabels = { "Visualized Cnet" }, returnTypes = { JComponent.class }, parameterLabels = {
		"CNet" }, userAccessible = false)
@Visualizer
public class CNetVisualization {
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, CNet cnet) {
		System.gc();

		// create a graph
		ViewSpecificAttributeMap viewSpecificMap = new ViewSpecificAttributeMap();

		// create a directed graph
		CNetV graph = new CNetV(cnet);
		
		for (CNetVNode node : graph.getNodes()){
			if (node.getNode().equals(cnet.getStartNode())){
				viewSpecificMap.putViewSpecific(node, AttributeMap.STROKECOLOR, Color.GREEN);
				viewSpecificMap.putViewSpecific(node, AttributeMap.BORDERWIDTH, 3);
			}
			
			if (node.getNode().equals(cnet.getEndNode())){
				viewSpecificMap.putViewSpecific(node, AttributeMap.STROKECOLOR, Color.RED);
				viewSpecificMap.putViewSpecific(node, AttributeMap.BORDERWIDTH, 3);
			}
			
		}
		
		return ProMJGraphVisualizer.instance().visualizeGraph(context, graph, viewSpecificMap);
	}
}
