/**
 * 
 */
package org.processmining.plugins.petrinet.replayer.algorithms;

import nl.tue.astar.AStarThread.Canceller;

/**
 * @author aadrians Oct 21, 2011
 * 
 */
public abstract class AbstractDefaultPNReplayParam implements IPNReplayParameter {

	protected boolean createConn = false;
	protected boolean guiMode = false;
	protected Canceller canceller;
	private int numThreads = 1;

	/**
	 * Return true if connections need to be made after replay is finished
	 */
	public boolean isCreatingConn() {
		return createConn;
	}

	/**
	 * Return true if GUI is used
	 */
	public boolean isGUIMode() {
		return guiMode;
	}

	/**
	 * value is true if later the algorithm is expected to give GUI notification
	 */
	public void setGUIMode(boolean value) {
		this.guiMode = value;
	}

	/**
	 * value is true if the replay result of the algorithm is expected to be
	 * visualized
	 */
	public void setCreateConn(boolean value) {
		this.createConn = value;
	}

	public Canceller getCanceller() {
		return canceller;
	}

	public void setCanceller(Canceller canceller) {
		this.canceller = canceller;
	}
	
	public int getNumThreads() {
		return numThreads;
	}

	public void setNumThreads(int numThreads) {
		this.numThreads = numThreads;
	}

}
