package org.processmining.plugins.pnml.elements;

import org.processmining.plugins.pnml.base.Pnml;
import org.processmining.plugins.pnml.elements.extensions.opennet.PnmlLabel;
import org.processmining.plugins.pnml.toolspecific.PnmlToolSpecific;

public class DefaultPnmlElementFactory {

	public PnmlReferencePlace createPnmlReferencePlace() {
		return new PnmlReferencePlace();
	}

	public PnmlNet createPnmlNet() {
		return new PnmlNet();
	}

	public PnmlToolSpecific createPnmlToolSpecific() {
		return new PnmlToolSpecific();
	}

	public PnmlName createPnmlName() {
		return new PnmlName();
	}

	public PnmlName createPnmlName(String name) {
		return new PnmlName(name);
	}

	public PnmlReferenceTransition createPnmlReferenceTransition() {
		return new PnmlReferenceTransition();
	}

	public PnmlTransition createPnmlTransition() {
		return new PnmlTransition();
	}

	public PnmlPlace createPnmlPlace() {
		return new PnmlPlace();
	}

	public PnmlArc createPnmlArc() {
		return new PnmlArc();
	}

	public Pnml createPnml() {
		return new Pnml();
	}

	public PnmlText createPnmlText(String text) {
		return new PnmlText(text);
	}

	public PnmlText createPnmlText() {
		return new PnmlText();
	}

	public PnmlLabel.Output createPnmlLabelOutput() {
		return new PnmlLabel.Output();
	}

	public PnmlLabel.Sync createPnmlLabelSync() {
		return new PnmlLabel.Sync();
	}

	public PnmlLabel.Input createPnmlLabelInput() {
		return new PnmlLabel.Input();
	}

	public PnmlPage createPnmlPage() {
		return new PnmlPage();
	}

}
