package org.processmining.plugins.properties.processmodel.abstractproperty;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import javax.swing.ImageIcon;

import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.gui.GUIProperty;
import org.processmining.plugins.properties.processmodel.gui.impl.GUIPropertyDefault;

/**
 * 
 * @author DSchunse
 *
 * @param <K>
 */
@SuppressWarnings("serial")
public abstract class HighLevelProperty<K> implements Property<K> {
	public boolean equals(Object o){
		return (o instanceof HighLevelProperty<?>) ? ((HighLevelProperty<?>)o).getID().equals(this.getID()) : false;
	}
	
	public int hashCode(){
		return this.getID().hashCode();
	}
	
	public final String toString(){
		return getName();
	}
	
	public Collection<Class<? extends Property<?>>> getDependencies(){
		return new HashSet<Class<? extends Property<?>>>();
	}
	
	public Set<Constructs> monotonicity() {
		return new HashSet<Constructs>();
	}

	public Set<Constructs> getMeaningfulTypeConstructs() {
		// make everything propertable, so we can at least see the property if we do not specify any thing
		Set<Constructs> constructs = new HashSet<Constructs>();
		for(int i = 0; i < Constructs.values().length; i++){
			constructs.add(Constructs.values()[i]);
		}
		return constructs;
	}
	
	public double getValueDouble(Object value) {
		return 0;
	}
	
	public int compare(Object o1, Object o2) {
		return 0;
	}

	public ImageIcon getIcon() {
		return null;
	}

	public GUIProperty<K> getGUIProperty() throws InstantiationException, IllegalAccessException {
		return new GUIPropertyDefault<K>();
	}

	public boolean hasOrdering() {
		return false;
	}

	public boolean higherBetter() {
		return false;
	}
}
