package org.processmining.plugins.properties.processmodel.abstractproperty;

import org.processmining.plugins.properties.enumerations.DistributionType;
import org.processmining.plugins.properties.enumerations.TimeOptions;
import org.processmining.plugins.properties.processmodel.impl.Distribution;

/**
 * 
 * @author DSchunse
 *
 */
@SuppressWarnings("serial")
public abstract class PropertyDistribution extends HighLevelProperty<Distribution> {
	
	public Double probability;
	public Long trials;
	public Double mode;
	public Double scaleFactor;
	public Double translationConstant;
	
	public String marshall(Object values){
		Distribution distr = (Distribution)values;
		return "<valueEntry " +
				"distributionType=\"" + distr.getDistributionType() + "\" " +
				"timeGranularity=\"" + distr.getTimeGranularity() + "\" " +
				"mean=\"" + distr.getMean() + "\" " +
				"variance=\"" + distr.getVariance() + "\" " +
				"minimum=\"" + distr.getMinimum() + "\" " +
				"maximum=\"" + distr.getMaximum() + "\" " +
				"number=\"" + distr.getNumber() + "\" " +
				"shape=\"" + distr.getShape() + "\" " +
				"scale=\"" + distr.getScale() + "\" " +
				"probability=\"" + distr.getProbability() + "\" " +
				"trials=\"" + distr.getTrials() + "\" " +
				"mode=\"" + distr.getMode() + "\" " +
				"scaleFactor=\"" + distr.getScaleFactor() + "\" " +
				"translationConstant=\"" + distr.getTranslationConstant() + "\" " +
				"/>\n";
	}
	
	public Object unmarshall(String xml){
		// well we have the XML structure above, have fun :-)
		// note that values can be null
		Distribution distr = new Distribution();
		// distribution type
		distr.setDistributionType(DistributionType.valueOf(xml.split("distributionType=\"")[1].split("\"")[0]));
		distr.setTimeGranularity(TimeOptions.valueOf(xml.split("timeGranularity=\"")[1].split("\"")[0]));
		
		if(!xml.split("mean=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setMean(Double.valueOf(xml.split("mean=\"")[1].split("\"")[0]));
		}
		if(!xml.split("variance=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setVariance(Double.valueOf(xml.split("variance=\"")[1].split("\"")[0]));
		}
		if(!xml.split("minimum=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setMinimum(Double.valueOf(xml.split("minimum=\"")[1].split("\"")[0]));
		}
		if(!xml.split("maximum=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setMaximum(Double.valueOf(xml.split("maximum=\"")[1].split("\"")[0]));
		}
		if(!xml.split("number=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setNumber(Long.valueOf(xml.split("number=\"")[1].split("\"")[0]));
		}
		if(!xml.split("shape=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setShape(Double.valueOf(xml.split("shape=\"")[1].split("\"")[0]));
		}
		if(!xml.split("scale=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setScale(Double.valueOf(xml.split("scale=\"")[1].split("\"")[0]));
		}
		if(!xml.split("probability=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setProbability(Double.valueOf(xml.split("probability=\"")[1].split("\"")[0]));
		}
		if(!xml.split("trials=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setTrials(Long.valueOf(xml.split("trials=\"")[1].split("\"")[0]));
		}
		if(!xml.split("mode=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setMode(Double.valueOf(xml.split("mode=\"")[1].split("\"")[0]));
		}
		if(!xml.split("scaleFactor=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setScaleFactor(Double.valueOf(xml.split("scaleFactor=\"")[1].split("\"")[0]));
		}
		if(!xml.split("translationConstant=\"")[1].split("\"")[0].equalsIgnoreCase("null")){
			distr.setTranslationConstant(Double.valueOf(xml.split("translationConstant=\"")[1].split("\"")[0]));
		}
		return distr;		
	}
	
	public Distribution clone(Object element){
		return new Distribution((Distribution) element);
	}
}
