package org.processmining.plugins.properties.processmodel.configurable.abstractproperty;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import javax.swing.ImageIcon;

import org.processmining.framework.util.Pair;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.configurable.ConfigurableProperty;
import org.processmining.plugins.properties.processmodel.configurable.ConfigurablePropertyConfiguration;
import org.processmining.plugins.properties.processmodel.configurable.ConfigurablePropertyIterator;
import org.processmining.plugins.properties.processmodel.gui.GUIProperty;
import org.processmining.plugins.properties.processmodel.gui.impl.GUIPropertyDefault;

/**
 * 
 * @author DSchunse
 *
 * @param <K>
 */
@SuppressWarnings("serial")
public abstract class ConfigurableHighLevelProperty<K> implements ConfigurableProperty<K>{

	public boolean equals(Object o){
		return (o instanceof ConfigurableHighLevelProperty<?>) ? ((ConfigurableHighLevelProperty<?>)o).getID().equals(this.getID()) : false;
	}
	
	public int hashCode(){
		return this.getID().hashCode();
	}
	
	public final String toString(){
		return getName();
	}
	
	public Collection<Class<? extends Property<?>>> getDependencies(){
		return new HashSet<Class<? extends Property<?>>>();
	}
	
	@SuppressWarnings("unchecked")
	public Object instantiate(Object elements, Object config){
		return this.instantiate(elements, (ConfigurablePropertyConfiguration<K>)config);
	}

	@SuppressWarnings("unchecked")
	public Object instantiateTotal(Object elements, Object config){
		return this.instantiateTotal(elements, (ConfigurablePropertyConfiguration<K>)config);
	}
	
	@SuppressWarnings("unchecked")
	public ConfigurablePropertyIterator<K> getIterator(Object values) {
		return new ConfigurablePropertyIteratorImpl<K>(this, (Pair<K, K>) values);
	}
	
	public Set<Constructs> monotonicity() {
		return new HashSet<Constructs>();
	}

	public Set<Constructs> getMeaningfulTypeConstructs() {
		try {
			return getNonConfigurableVariant().newInstance().getMeaningfulTypeConstructs();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return new HashSet<Constructs>();
	}
	
	public double getValueDouble(Object value) {
		return 0;
	}
	
	public int compare(Object o1, Object o2) {
		return 0;
	}

	public ImageIcon getIcon() {
		return null;
	}

	public GUIProperty<Pair<K, K>> getGUIProperty() throws InstantiationException, IllegalAccessException {
		return new GUIPropertyDefault<>();
	}

	public boolean hasOrdering() {
		return false;
	}

	public boolean higherBetter() {
		return false;
	}

}
