package org.processmining.plugins.properties.processmodel.configurable.impl;

import java.util.List;

import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.configurable.ConfigurablePropertyConfiguration;
import org.processmining.plugins.properties.processmodel.configurable.abstractproperty.ConfigurablePropertyDistribution;
import org.processmining.plugins.properties.processmodel.impl.AutomaticDistribution;
import org.processmining.plugins.properties.processmodel.impl.Distribution;

/**
 * 
 * @author DSchunse
 *
 */
@PropertableElementProperty
public class ConfigurableAutomaticDistribution extends ConfigurablePropertyDistribution{
	private static final long serialVersionUID = -7381109942238087587L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "Configurable Automatic Distribution";
	}
	
	@Override
	public Object instantiateTotal(Object elements, ConfigurablePropertyConfiguration<List<Distribution>> config) {
		// we need to check if this is a total configuration, if so, then return a single value to be used
		if(this.isTotalConfiguration(elements, config)){
			return new AutomaticDistribution((Distribution) super.instantiateTotal(elements, config));
		}
		else{
			return super.instantiate(elements, config);
		}
	}
	
	public Class<? extends Property<?>> getNonConfigurableVariant() {
		return AutomaticDistribution.class;
	}
}
