package org.processmining.plugins.properties.processmodel.configurable.impl;

import org.processmining.plugins.properties.annotations.OriginatorPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.configurable.abstractproperty.ConfigurablePropertyListString;
import org.processmining.plugins.properties.processmodel.impl.McDonaldsIndex;

/**
 * 
 * @author DSchunse
 *
 */
@PropertableElementProperty
@OriginatorPerspective
public class ConfigurableMcDonaldsIndex extends ConfigurablePropertyListString{

	private static final long serialVersionUID = 540964199395115455L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "Configurable McDonald's Index";
	}
	
	public Class<? extends Property<?>> getNonConfigurableVariant() {
		return McDonaldsIndex.class;
	}
}
