package org.processmining.plugins.properties.processmodel.gui.impl;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JComponent;

import org.processmining.plugins.properties.processmodel.PropertableElement;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.AddButton;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.GUIPropertySinglePage;
import org.processmining.plugins.properties.processmodel.impl.DataValues;
import org.processmining.plugins.properties.processmodel.impl.InitialDataValue;

import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * 
 * @author DSchunse
 *
 */
public class GUIPropertyInitialDataValue extends GUIPropertySinglePage<String>{

	public <E extends PropertableElement, P extends Property<?>> void fillGUI(P prop, E element, AddButton button, List<List<JComponent>> dataRows, boolean independent) throws InstantiationException, IllegalAccessException{
		// we only have a single data row so we can set it directly
		if(independent){
			((JComboBox)dataRows.get(0).get(0)).setSelectedItem(element.getIndependentProperty(prop));
		}
		else{
			((JComboBox)dataRows.get(0).get(0)).setSelectedItem(element.getDependentProperty(prop));
		}
	}

	@SuppressWarnings("unchecked")
	public <E extends PropertableElement> List<List<JComponent>> getDataRow(E element) throws InstantiationException, IllegalAccessException{
		ArrayList<List<JComponent>> dataRows = new ArrayList<List<JComponent>>();
		ArrayList<JComponent> dataRow = new ArrayList<JComponent>();
		List<String> values = ((List<String>)element.getIndependentProperty(DataValues.class));
		if(element.getIndependentProperty(InitialDataValue.class) != null && !values.contains(element.getIndependentProperty(InitialDataValue.class))){
			values.add((String)element.getIndependentProperty(InitialDataValue.class));
		}
		dataRow.add(SlickerFactory.instance().createComboBox(values.toArray()));
		dataRows.add(dataRow);
		return dataRows;
	}

	public <P extends Property<?>> String parseComponents(P property, List<List<List<Object>>> lines) throws InstantiationException, IllegalAccessException{
		return (String)lines.get(0).get(0).get(0);
	}

}
