package org.processmining.plugins.properties.processmodel.gui.impl;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTextField;

import org.processmining.plugins.properties.enumerations.TimeOptions;
import org.processmining.plugins.properties.processmodel.PropertableElement;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.TimeValue;
import org.processmining.plugins.properties.processmodel.abstractproperty.TimeValueImpl;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.AddButton;

import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * 
 * @author DSchunse
 *
 */
public class GUIPropertyListTimeValue extends GUIPropertyList<TimeValue>{

	@SuppressWarnings("unchecked")
	public <E extends PropertableElement, P extends Property<?>> void fillGUI(P prop, E element, AddButton button, List<List<JComponent>> dataRows, boolean independent) throws InstantiationException, IllegalAccessException{
		// now just set all of the fields and call the button
		List<TimeValue> values = (List<TimeValue>)element.getIndependentProperty(prop);
		if(values != null){
			// we need to have present absent, so also set the labels correct
			for(int i = 0; i < values.size(); i += 2){
				((JLabel)dataRows.get(0).get(0)).setText("Present");
				((JTextField)dataRows.get(0).get(1)).setText(values.get(i).getValue().toString());
				((JComboBox)dataRows.get(0).get(2)).setSelectedItem(values.get(i).getTimeGranularity());
				
				((JLabel)dataRows.get(1).get(0)).setText("Absent");
				((JTextField)dataRows.get(1).get(1)).setText(values.get(i + 1).getValue().toString());
				((JComboBox)dataRows.get(1).get(2)).setSelectedItem(values.get(i + 1).getTimeGranularity());

				button.actionPerformed(null);
			}
		}
		
	}

	public <E extends PropertableElement> List<List<JComponent>> getHeaderRows(E element){
		ArrayList<List<JComponent>> header = new ArrayList<List<JComponent>>();
		JLabel lpresAb = SlickerFactory.instance().createLabel("Present/Absent");
		JLabel lTime = SlickerFactory.instance().createLabel("Amount of time");
		JLabel lTimeGran = SlickerFactory.instance().createLabel("Timespan");
		ArrayList<JComponent> head = new ArrayList<JComponent>();
		head.add(lpresAb);
		head.add(lTime);
		head.add(lTimeGran);
		header.add(head);
		return header;
	}

	public <E extends PropertableElement> List<List<JComponent>> getDataRow(E element) throws InstantiationException, IllegalAccessException{
		ArrayList<List<JComponent>> dataRows = new ArrayList<List<JComponent>>();
		ArrayList<JComponent> data = new ArrayList<JComponent>();
		data.add(new JLabel());
		data.add(new JTextField(60));
		data.add(new JComboBox(TimeOptions.values()));
		dataRows.add(data);
		data = new ArrayList<JComponent>();
		data.add(new JLabel());
		data.add(new JTextField(60));
		data.add(new JComboBox(TimeOptions.values()));
		dataRows.add(data);
		return dataRows;
	}

	@SuppressWarnings("unchecked")
	public <P extends Property<?>> ArrayList<TimeValue> parseComponents(P property, List<List<List<Object>>> lines) throws InstantiationException, IllegalAccessException{
		ArrayList<TimeValue> datavalues = new ArrayList<TimeValue>();
		for(List<List<Object>> value: lines){
			// we have 2 of them
			Double timeValue = Double.valueOf(String.valueOf(value.get(0).get(1)));
			TimeOptions timeGranularity = TimeOptions.valueOf(String.valueOf(value.get(0).get(2))); 
			TimeValue tVal = new TimeValueImpl(timeGranularity, timeValue);
			datavalues.add(tVal);
			timeValue = Double.valueOf(String.valueOf(value.get(1).get(1)));
			timeGranularity = TimeOptions.valueOf(String.valueOf(value.get(1).get(2))); 
			tVal = new TimeValueImpl(timeGranularity, timeValue);
			datavalues.add(tVal);
		}
		if(datavalues.size() == 0){
			// we have a special case
			datavalues = (ArrayList<TimeValue>) property.getDefaultValue();
		}
		return datavalues;
	}

}
