package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

import javax.swing.ImageIcon;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PointProbability;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@PropertableElementProperty
public class EventTime extends PointProbability{

	private static final long serialVersionUID = 6697705505907948666L;

	public Long getID() {
		return serialVersionUID;
	}

	public HashMap<Double, Double> getDefaultValue() {
		HashMap<Double, Double> ret = new HashMap<Double, Double>();
		ret.put(0d, 1d);
		return ret;
	}

	public ImageIcon getIcon() {
		return null;
	}

	public String getName() {
		return "EventTime";
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs = new HashSet<Constructs>();
		constructs.add(Constructs.Event);
		return constructs;
	}
}
