package org.processmining.plugins.properties.processmodel.impl;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import javax.swing.ImageIcon;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.DataPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyString;
import org.processmining.plugins.properties.processmodel.gui.GUIProperty;
import org.processmining.plugins.properties.processmodel.gui.impl.GUIPropertyInitialDataValue;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@DataPerspective
@PropertableElementProperty
public class InitialDataValue extends PropertyString {

	private static final long serialVersionUID = 6858242719283578195L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "InitialValue";
	}
	
	public Collection<Class<? extends Property<?>>> getDependencies(){
		Collection<Class<? extends Property<?>>> dep = new HashSet<Class<? extends Property<?>>>();
		dep.add(DataValues.class);
		return dep;
	}

	public int compare(Object o1, Object o2) {
		return 0;
	}

	public String getDefaultValue() {
		return "UNKNOWN";
	}

	public double getValueDouble(Object value) {
		return 0;
	}

	public ImageIcon getIcon() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean hasOrdering() {
		return false;
	}

	public boolean higherBetter() {
		return false;
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs = new HashSet<Constructs>();
		constructs.add(Constructs.Variable);
		return constructs;
	}
	
	public GUIProperty<String> getGUIProperty() throws InstantiationException, IllegalAccessException {
		return GUIPropertyInitialDataValue.class.newInstance();
	}
}
