package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.ControlFlowPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyMapIntegerDouble;
import org.processmining.plugins.properties.processmodel.gui.GUIProperty;
import org.processmining.plugins.properties.processmodel.gui.impl.GUIPropertyNrOfCases;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@PropertableElementProperty
@ControlFlowPerspective
public class NrOfCases extends PropertyMapIntegerDouble{

	private static final long serialVersionUID = -7050344540264564293L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "Number of cases";
	}

	public Map<Integer, Double> getDefaultValue() {
		return new HashMap<Integer, Double>();
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constr = new HashSet<Constructs>();
		constr.add(Constructs.Node);
		constr.add(Constructs.Edge);
		constr.add(Constructs.Model);
		constr.add(Constructs.Originator);
		return constr;
	}
	
	public GUIProperty<Map<Integer, Double>> getGUIProperty() throws InstantiationException, IllegalAccessException {
		return GUIPropertyNrOfCases.class.newInstance();
	}

}
