package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.ControlFlowPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyInteger;

@KeepInProMCache
@PropertableElementProperty
@ControlFlowPerspective
public class NrOfControlTasks extends PropertyInteger{
	private static final long serialVersionUID = -7035999384128352631L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "Number of Control Tasks";
	}

	public Integer getDefaultValue() {
		return 0;
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constr = new HashSet<Constructs>();
		constr.add(Constructs.AutomaticTask);
		constr.add(Constructs.ManualTask);
		constr.add(Constructs.Model);
		return constr;
	}
	
	public int compare(Object o1, Object o2) {
		if(o1 instanceof Integer && o2 instanceof Integer){
			return Integer.compare((int) o1, (int) o2);
		}
		return 0;
	}
	
	public boolean hasOrdering() {
		return true;
	}

	public boolean higherBetter() {
		return true;
	}

}
