package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.ControlFlowPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyDouble;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@PropertableElementProperty
@ControlFlowPerspective
public class OutgoingProbability extends PropertyDouble{
	private static final long serialVersionUID = -9109660277858330815L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "Outgoing Probability";
	}

	public Double getDefaultValue() { 
		return 1d;
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs(){
		Set<Constructs> ret = new HashSet<Constructs>();
		//ret.add(Constructs.DeferredChoice);
		//ret.add(Constructs.DeferredChoiceLoop);
		//ret.add(Constructs.ExclusiveChoice);
		//ret.add(Constructs.ExclusiveChoiceLoop);
		//ret.add(Constructs.OR);
		ret.add(Constructs.Edge);
		return ret;
	}

}
