package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.ExperimentPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyLong;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@PropertableElementProperty
@ExperimentPerspective
public class RunningTime extends PropertyLong{

	private static final long serialVersionUID = -1876344660468731167L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "RunningTime";
	}

	public Long getDefaultValue() {
		return 0l;
	}

	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constr =  new HashSet<Constructs>();
		constr.add(Constructs.Model);
		return constr;
	}
	
	public int compare(Object o1, Object o2) {
		return Long.compare((Long)o1, (Long)o2);
	}
}
