package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PointProbabilityOrder;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@PropertableElementProperty
public class ThroughputTimeOrder extends PointProbabilityOrder {
	private static final long serialVersionUID = -8174008339248178700L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "ThroughputOrder";
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs = new HashSet<Constructs>();
		constructs.add(Constructs.Node);
		constructs.add(Constructs.Model);
		return constructs;
	}
}
