package org.processmining.processtree;


/**
 * Originators are identifiable by their identifier. Any subclass of originator with
 * the same identifier is assumed to be the same.
 * 
 * @author bfvdonge && DSchunse
 * 
 */
public interface Originator extends ProcessTreeElement {
	/**
	 * Resource
	 * 
	 * @author bfvdonge
	 * 
	 */
	public interface Resource extends Originator {

	}

	/**
	 * Group
	 * 
	 * @author bfvdonge
	 * 
	 */
	public interface Group extends Originator {

	}

	/**
	 * Role
	 * 
	 * @author bfvdonge
	 * 
	 */
	public interface Role extends Originator {

	}
}
