package org.processmining.processtree.configuration;

import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.configuration.controlflow.ControlFlowConfiguration;
import org.processmining.processtree.configuration.data.DataConfiguration;
import org.processmining.processtree.configuration.originator.OriginatorConfiguration;

/**
 * Configuration is a container of the various configurations, e.g. control flow, data, and originator
 * @author DSchunse
 */
public interface Configuration {
	void setControlFlowConfiguration(ControlFlowConfiguration controlFlowConfiguration);
	
	ControlFlowConfiguration getControlFlowConfiguration();
	
	void setOriginatorConfiguration(OriginatorConfiguration originatorConfiguration);
	
	OriginatorConfiguration getOriginatorConfiguration();
	
	void setDataConfiguration(DataConfiguration dataConfiguration);
	
	DataConfiguration getDataConfiguration();
	
	String toString(ProcessTree pt);
}
