package org.processmining.processtree.configuration;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processtree.configuration.controlflow.impl.ControlFlowConfigurationExport;

@Plugin(name = "Process Tree Configuration Export", returnLabels = {}, returnTypes = {}, parameterLabels = { "Process Tree Configuration",
"File" }, userAccessible = true)
@UIExportPlugin(description = "Process Tree Configuration files", extension = "ptcf")
public class ConfigurationExport {

	@PluginVariant(variantLabel = "Process Tree Configuration Export", requiredParameterLabels = { 0, 1 })
	public void exportDefault(UIPluginContext context, Configuration conf, File file) throws IOException {
		exportPrivate(context, conf, file);
	}
	
	public void exportDefault(PluginContext context, Configuration conf, File file) throws IOException {
		exportPrivate(context, conf, file);
	}

	private void exportPrivate(PluginContext context, Configuration conf, File file)
			throws IOException {
		String text = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";
		text += ControlFlowConfigurationExport.export(false, conf.getControlFlowConfiguration());
		
		text += "</xml>";
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file)));
		bw.write(text);
		bw.close();
	}
}
