package org.processmining.processtree.configuration.data.impl;

import org.processmining.processtree.Edge;
import org.processmining.processtree.Expression;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.configuration.data.DataConfiguration;
import org.processmining.processtree.configuration.data.DataConfigurationInstantiater;
import org.processmining.processtree.impl.ProcessTreeImpl;

public class DataConfigurationInstantiaterImpl implements DataConfigurationInstantiater{

	public ProcessTree instantiate(ProcessTree tree, DataConfiguration conf) {
		return instantiate(tree, conf, false);
	}

	public ProcessTree instantiate(ProcessTree treeIn, DataConfiguration conf, Boolean makeConfigurationComplete) {
		if(makeConfigurationComplete){
			DataConfigurationIteratorImpl.makeComplete(conf, treeIn);
		}
		ProcessTree treeOut = new ProcessTreeImpl(treeIn);
		// now just initialise all things
		for(Node n: treeOut.getNodes()){
			n.getRemovableReadVariables().removeAll(conf.getRemovedRead(n.getID()));
			n.getRemovableReadVariables().removeAll(conf.getNonRemovedRead(n.getID()));
			n.getReadVariables().removeAll(conf.getRemovedRead(n.getID()));
			
			n.getRemovableWrittenVariables().removeAll(conf.getRemovedWritten(n.getID()));
			n.getRemovableWrittenVariables().removeAll(conf.getNonRemovedWritten(n.getID()));
			n.getWrittenVariables().removeAll(conf.getRemovedWritten(n.getID()));
		}
		for(Edge e: treeOut.getEdges()){
			// do a check on the amount of expressions
			if(conf.getSelectedExpression(e.getID()) == null){
				e.getRemovableExpressions().removeAll(conf.getNonSelectedExpression(e.getID()));
			}
			else{
				e.getRemovableExpressions().clear();
				e.setExpression((Expression) treeOut.getElement(conf.getSelectedExpression(e.getID())));
			}
			
		}
		return treeOut;
	}

}
