package org.processmining.processtree.configuration.originator.impl;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.UUID;

import org.processmining.processtree.configuration.originator.OriginatorConfiguration;

public class OriginatorConfigurationImpl implements OriginatorConfiguration{
	
	Map<UUID, Set<UUID>> removedOriginator;
	Map<UUID, Set<UUID>> nonRemovedOriginator;

	public OriginatorConfigurationImpl(){
		this.removedOriginator = new HashMap<UUID, Set<UUID>>();
		this.nonRemovedOriginator = new HashMap<UUID, Set<UUID>>();
	}

	public void addRemovedOriginator(UUID node, UUID originator) {
		Set<UUID> elements = removedOriginator.get(node);
		if(elements == null){
			elements = new HashSet<UUID>();
		}
		elements.add(originator);
		removedOriginator.put(node, elements);
	}

	public void addNonRemovedOriginator(UUID node, UUID originator) {
		Set<UUID> elements = nonRemovedOriginator.get(node);
		if(elements == null){
			elements = new HashSet<UUID>();
		}
		elements.add(originator);
		nonRemovedOriginator.put(node, elements);
	}

	public Set<UUID> getRemovedOriginator(UUID node) {
		if(removedOriginator.get(node) != null){
			return removedOriginator.get(node);
		}
		else{
			// just return an empty structure
			return new HashSet<UUID>();
		}
	}

	public Set<UUID> getNonRemovedOriginator(UUID node) {
		if(nonRemovedOriginator.get(node) != null){
			return nonRemovedOriginator.get(node);
		}
		else{
			// just return an empty structure
			return new HashSet<UUID>();
		}
	}

	public Map<UUID, Set<UUID>> getRemovedOriginator() {
		return removedOriginator;
	}

	public Map<UUID, Set<UUID>> getNonRemovedOriginator() {
		return nonRemovedOriginator;
	}

}
