package org.processmining.processtree.configuration.originator.impl;

import java.util.HashSet;
import java.util.Set;
import java.util.UUID;

import org.processmining.processtree.Node;
import org.processmining.processtree.Originator;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.Task.Manual;
import org.processmining.processtree.configuration.originator.OriginatorConfiguration;
import org.processmining.processtree.configuration.originator.OriginatorConfigurationInstantiater;
import org.processmining.processtree.impl.ProcessTreeImpl;


public class OriginatorConfigurationInstantiaterImpl implements OriginatorConfigurationInstantiater{

	public ProcessTree instantiate(ProcessTree tree, OriginatorConfiguration conf) {
		return instantiate(tree, conf, false);
	}

	public ProcessTree instantiate(ProcessTree treeIn, OriginatorConfiguration conf, Boolean makeConfigurationComplete) {
		if(makeConfigurationComplete){
			OriginatorConfigurationIteratorImpl.makeComplete(conf, treeIn);
		}
		ProcessTree treeOut = new ProcessTreeImpl(treeIn);
		// now just initialise all things
		for(Node n: treeOut.getNodes()){
			if(n instanceof Manual){
				for(UUID id: conf.getNonRemovedOriginator(n.getID())){
					((Manual)n).getRemovableOriginators().remove(treeOut.getElement(id));
				}
				for(UUID id: conf.getRemovedOriginator(n.getID())){
					((Manual)n).getOriginators().remove(treeOut.getElement(id));
					((Manual)n).getRemovableOriginators().remove(treeOut.getElement(id));
				}
			}
		}
		return treeOut;
	}
	
	public boolean isValid(ProcessTree tree, OriginatorConfiguration conf){
		boolean valid = true;
		for(Node n: tree.getNodes()){
			if(n instanceof Manual){
				for(UUID id: conf.getRemovedOriginator(n.getID())){
					valid &= ((Manual)n).getRemovableOriginators().contains(tree.getElement(id));
				}
				// also check that we do not remove all originators
				Set<UUID> orgIds = new HashSet<UUID>();
				for(Originator org: ((Manual) n).getOriginators()){
					orgIds.add(org.getID());
				}
				orgIds.removeAll(conf.getRemovedOriginator(n.getID()));
				valid &= !orgIds.isEmpty();
			}
		}
		return valid;
	}

}
