package org.processmining.processtree.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.processtree.arrays.ProcessTreeArray;
import org.processmining.processtree.arrays.impl.ConfigurationArrayImpl;

/**
 * Connects a {@link ConfigurationArray} object to an {@link ProcessTreeArray}
 * using a weak connection (e.g. the connection is removed whenever one of these
 * is removed).
 * 
 * @author jbuijs
 * 
 */
public class ConfigurationArrayToProcessTreeArrayConnection extends AbstractConnection {

	public static final String PROCESSTREEARRAY = "PROCESSTREEARRAY";

	public static final String CONFIGURATIONARRAY = "CONFIGURATIONARRAY";

	public ConfigurationArrayToProcessTreeArrayConnection(ConfigurationArrayImpl configurationArray,
			ProcessTreeArray processTreeArray) {
		super("Configuration array to Process Tree array");
		put(PROCESSTREEARRAY, processTreeArray);
		put(CONFIGURATIONARRAY, configurationArray);
	}

}
