package org.processmining.processtree.editor.editorpanel;

import java.awt.event.ActionEvent;
import java.util.UUID;

import javax.swing.JComboBox;

import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.ProcessTreeElement;
import org.processmining.processtree.editor.interaction.GraphMouseListener;

public class EditorActionListenerPropertyButton implements EditorActionListener{
	ProcessTree tree;
	JComboBox<Property<?>> comboBox;
	Boolean addProperty;
	GraphMouseListener graphMouseListener;
	
	public EditorActionListenerPropertyButton(ProcessTree tree, JComboBox<Property<?>> comboBox, Boolean addProperty, GraphMouseListener graphMouseListener){
		this.tree = tree;
		this.comboBox = comboBox;
		this.addProperty = addProperty;
		this.graphMouseListener = graphMouseListener;
	}

	public void actionPerformed(ActionEvent e) {
		if(!isEnabled()){
			return;
		}
		UUID selectedID = graphMouseListener.getSelectedID();
		ProcessTreeElement element = tree.getElement(selectedID);
		// now either add or remove a property
		if(addProperty){
			try {
				element.setIndependentProperty(((Property<?>) comboBox.getSelectedItem()), ((Property<?>)comboBox.getSelectedItem()).getDefaultValue());
			} catch (IllegalAccessException | InstantiationException e1) {
				e1.printStackTrace();
			}
		}
		else{
			element.getIndependentProperties().remove(comboBox.getSelectedItem());
		}
		graphMouseListener.setSelectedID(selectedID);
		
	}
	
	public boolean isEnabled(){
		UUID selectedID = graphMouseListener.getSelectedID();
		if(selectedID == null){
			return false;
		}
		else{
			return comboBox.getItemCount() > 0 && comboBox.getSelectedItem() != null;
		}
	}
	

}
