package org.processmining.processtree.editor.editorpanel;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.List;
import java.util.UUID;

import javax.swing.JTextField;

import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.ProcessTreeElement;
import org.processmining.processtree.editor.graphpanel.GraphPanel;
import org.processmining.processtree.editor.interaction.GraphMouseListener;

public class EditorKeyListenerNameField implements KeyListener{
	ProcessTree tree;
	GraphMouseListener graphMouseListener;
	GraphPanel graphPanel;
	JTextField nameField;
	private int caretPosition;
	private int selectionStart;
	private int selectionEnd;
	private List<Class<? extends ProcessTreeElement>> validElements;
	
	public EditorKeyListenerNameField(ProcessTree tree, GraphMouseListener graphMouseListener, GraphPanel graphPanel, JTextField nameField, List<Class<? extends ProcessTreeElement>> validElements){
		this.tree = tree;
		this.graphMouseListener = graphMouseListener;
		this.graphPanel = graphPanel;
		this.nameField = nameField;
		this.validElements = validElements;
	}
	
	public void keyPressed(KeyEvent arg0) {
		doSomething();
	}
	public void keyReleased(KeyEvent arg0) {
		doSomething();
	}
	public void keyTyped(KeyEvent arg0) {
		doSomething();
	}
	
	private void doSomething(){
		UUID selectedID = graphMouseListener.getSelectedID();
		if(tree.getElement(selectedID) != null){
			for(Class<? extends ProcessTreeElement> element: validElements){
				if(element.isInstance(tree.getElement(selectedID))){
					caretPosition = nameField.getCaretPosition();
					selectionStart = nameField.getSelectionStart();
					selectionEnd = nameField.getSelectionEnd();
					tree.getElement(selectedID).setName(nameField.getText());
					graphPanel.redraw();
					nameField.setCaretPosition(caretPosition);
					nameField.setSelectionStart(selectionStart);
					nameField.setSelectionEnd(selectionEnd);
					break;
				}
			}
		}
	}
	

}
