package org.processmining.processtree.impl;

import java.util.UUID;

import org.processmining.processtree.Originator;

public abstract class AbstractOriginator extends ProcessTreeElementImpl implements Originator {

	public AbstractOriginator(String name) {
		this(UUID.randomUUID(), name);
	}
	
	public AbstractOriginator(UUID id, String name){
		super(id, name);
	}
	
	public AbstractOriginator(Originator o){
		super(o);
	}

	public static class Resource extends AbstractOriginator implements
			Originator.Resource {

		public Resource(String name) {
			super(name);
		}
		
		public Resource(UUID id, String name) {
			super(id, name);
		}
		
		public Resource(Originator.Resource o){
			super(o);
		}

	}

	public static class Group extends AbstractOriginator implements
			Originator.Group {

		public Group(String name) {
			super(name);
		}
		
		public Group(UUID id, String name) {
			super(id, name);
		}
		
		public Group(Originator.Group o){
			super(o);
		}

	}

	public static class Role extends AbstractOriginator implements
			Originator.Role {

		public Role(String name) {
			super(name);
		}
		
		public Role(UUID id, String name) {
			super(id, name);
		}
		
		public Role(Originator.Role o){
			super(o);
		}

	}
}
