package org.processmining.processtree.ptml;

import java.util.UUID;

import org.xmlpull.v1.XmlPullParser;

public abstract class PtmlEvent extends PtmlBlock {

	protected String message;

	public PtmlEvent(String tag, UUID id) {
		super(tag, id);
		message = null;
	}
	
	protected void importAttributes(XmlPullParser xpp, Ptml ptml) {
		super.importAttributes(xpp, ptml);
		importMessage(xpp, ptml);
	}

	private void importMessage(XmlPullParser xpp, Ptml ptml) {
		String value = xpp.getAttributeValue(null, "message");
		if (value != null) {
			message = new String(value);
		}
		ptml.log(message != null ? value : "<no message>");
	}

	protected String exportAttributes(Ptml ptml) {
		return super.exportAttributes(ptml) + exportMessage(ptml);
	}

	private String exportMessage(Ptml ptml) {
		if (message != null) {
			return exportAttribute("message", message, ptml);
		}
		return "";
	}
}
