package org.processmining.processtree.ptml;

import java.util.Map;
import java.util.UUID;

import org.processmining.processtree.Expression;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.Variable;

public class PtmlIsUsed extends PtmlEdge {

	public final static String TAG = "usesVariable";

	public PtmlIsUsed(UUID id) {
		super(TAG, id);
	}

	public void unmarshall(ProcessTree tree, Map<UUID, Expression> exprMap, Map<UUID, Variable> variableMap) {
		Expression expr = exprMap.get(sourceId);
		Variable variable = variableMap.get(targetId);
		if (expr != null && variable != null) {
			expr.addVariable(variable);
		}
	}

	public void marshall(ProcessTree tree, Expression expr, Map<Expression, UUID> exprMap, Variable variable,
			Map<Variable, UUID> variableMap) {
		sourceId = exprMap.get(expr);
		targetId = variableMap.get(variable);
	}
}
