package org.processmining.processtree.ptml;

import java.util.Map;
import java.util.UUID;

import org.processmining.processtree.Originator;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.impl.AbstractOriginator;

public class PtmlRole extends PtmlOriginator {
	
	public final static String TAG = "role";
	
	public PtmlRole(UUID id) {
		super(TAG, id);
	}

	public void unmarshall(ProcessTree tree, Map<UUID, Originator> originatorMap) {
		Originator originator = new AbstractOriginator.Role(id, name);
		unmarshall(tree, originatorMap, originator);
	}
	
	public boolean equals(Object o) {
		return ((o instanceof PtmlRole) && (id.equals(((PtmlRole) o).id)));
	}
	
	public int hashCode() {
		return id.hashCode();
	}
}

