package org.processmining.processtree.ptml.exporting;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.ptml.Ptml;

@Plugin(name = "PTML export (Process tree)", level = PluginLevel.PeerReviewed, returnLabels = {}, returnTypes = {}, parameterLabels = { "Process tree",
		"File" }, userAccessible = true)
@UIExportPlugin(description = "PTML files", extension = "ptml")
public class PtmlExportTree {

	@PluginVariant(variantLabel = "PTML export (Process tree)", requiredParameterLabels = { 0, 1 })
	public void exportDefault(UIPluginContext context, ProcessTree tree, File file) throws IOException {
		exportPrivate(context, tree, file);
	}
	
	public void exportDefault(PluginContext context, ProcessTree tree, File file) throws IOException {
		exportPrivate(context, tree, file);
	}

	private void exportPrivate(PluginContext context, ProcessTree tree, File file)
			throws IOException {
		Ptml ptml = new Ptml().marshall(tree);
		String text = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n" + ptml.exportElement(ptml);

		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file)));
		bw.write(text);
		bw.close();
	}
}