package org.processmining.processtree.visualization;

import java.awt.geom.Rectangle2D;

public class Dim {

	public int x = 0;
	public int y = 0;
	public int width;
	public int height;
	private boolean left2right;

	public Dim(int width, int height, boolean left2right) {
		this.width = width;
		this.height = height;
		this.setLeft2right(left2right);
	}

	public Dim(Dim dim) {
		x = dim.x;
		y = dim.y;
		width = dim.width;
		height = dim.height;
		setLeft2right(dim.isLeft2right());
	}

	public String toString() {
		return "[width=" + width + ",height=" + height + ",x=" + x + ",y=" + y + "," + (isLeft2right() ? "L2R" : "R2L")
				+ "]";
	}

	public int hashCode() {
		return width + 37 * height + 37 * 37 * x + 37 * 37 * 37 * y;
	}

	public boolean equals(Object o) {
		return (o instanceof Dim) && ((Dim) o).width == width && ((Dim) o).height == height
				&& ((Dim) o).isLeft2right() == isLeft2right() && ((Dim) o).x == x && ((Dim) o).y == y;
	}

	public void setLocation(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public Rectangle2D toRectangle2D() {
		return new Rectangle2D.Double(x, y, width, height);
	}

	public void setLeft2right(boolean left2right) {
		this.left2right = left2right;
	}

	public boolean isLeft2right() {
		return left2right;
	}
}
