package org.processmining.processtree.visualization.bpmn;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JScrollPane;

import org.jgraph.JGraph;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.processtree.ProcessTree;

@Plugin(name = "Visualize Process tree as BPMN", level = PluginLevel.PeerReviewed, returnLabels = { "Visualized Process tree" }, returnTypes = { JComponent.class }, parameterLabels = {
		"Process tree" }, userAccessible = true)
@Visualizer
public class BPMNVisualization {

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, ProcessTree tree) {
		TreeBPMNLayoutBuilder builder = new TreeBPMNLayoutBuilder(tree, null);
		JGraph graph = builder.getJGraph();
		JFrame frame = new JFrame();
		frame.getContentPane().add(new JScrollPane(graph));		
		return (JComponent) frame.getContentPane();
	}

}
