package org.processmining.processtree.visualization.data;

import info.clearthought.layout.TableLayout;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.HashSet;

import javax.swing.AbstractAction;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;

import com.fluxicon.slickerbox.components.SlickerTabbedPane;
import com.fluxicon.slickerbox.factory.SlickerFactory;

public class AddButton extends AbstractAction{

	private static final long serialVersionUID = 1L;
	protected SlickerTabbedPane tabpane;
	protected ArrayList<ArrayList<Object>> lines;
	@SuppressWarnings("rawtypes")
	JComboBox nodeCombo;
	@SuppressWarnings("rawtypes")
	JComboBox variableCombo;
	JCheckBox read;
	JCheckBox write;

	@SuppressWarnings("rawtypes")
	public AddButton(JComboBox nodeCombo, JComboBox variableCombo, JCheckBox read, JCheckBox write, SlickerTabbedPane tabPane, ArrayList<ArrayList<Object>> lines){
		this.tabpane = tabPane;
		this.lines = lines;
		this.nodeCombo = nodeCombo;
		this.variableCombo = variableCombo;
		this.read = read;
		this.write = write;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		ArrayList<Object> line = new ArrayList<Object>();
		line.add(nodeCombo.getSelectedItem());
		line.add(variableCombo.getSelectedItem());
		line.add(read.isSelected());
		line.add(write.isSelected());
		int size = ((TableLayout)tabpane.getLayout()).getNumRow();
		((TableLayout)tabpane.getLayout()).insertRow(size, 30);
		JLabel nodeName = SlickerFactory.instance().createLabel("<HTML>" + nodeCombo.getSelectedItem().toString() + "</HTML>");
		JLabel variableName = SlickerFactory.instance().createLabel(variableCombo.getSelectedItem().toString());
		JLabel readLabel = SlickerFactory.instance().createLabel(read.isSelected() ? "R" : "");
		JLabel writeLabel = SlickerFactory.instance().createLabel(write.isSelected() ? "W" : "");
		HashSet<Component> comp = new HashSet<Component>();
		comp.add(nodeName);
		comp.add(variableName);
		comp.add(readLabel);
		comp.add(writeLabel);
		tabpane.add(nodeName, "0, " + size + ", 0, " + size + ", l, c");
		tabpane.add(variableName, "1, " + size + ", 1, " + size + ", c, c");
		tabpane.add(readLabel, "2, " + size + ", 2, " + size + ", c, c");
		tabpane.add(writeLabel, "3, " + size + ", 3, " + size + ", c, c");
		tabpane.revalidate();
	}

}
