package org.processmining.processtree.visualization.data;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JRadioButton;

import org.processmining.processtree.Edge;
import org.processmining.processtree.Expression;
import org.processmining.processtree.editor.graphpanel.GraphPanel;

public class ExpressionActionListener implements ActionListener{
	Edge edge;
	JRadioButton radioButton;
	JCheckBox listExpression;
	Expression expression;
	GraphPanel graphPanel;
	
	public ExpressionActionListener(Edge edge, GraphPanel graphPanel, JRadioButton radioButton, JCheckBox listExpression, Expression expression){
		this.edge = edge;
		this.radioButton = radioButton;
		this.listExpression = listExpression;
		this.expression = expression;
		this.graphPanel = graphPanel;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		if(radioButton != null && radioButton.isSelected()){
			edge.setExpression(expression);
			if(graphPanel != null){
				graphPanel.redraw();
			}
		}
		if(listExpression != null && listExpression.isSelected()){
			edge.getExpressions().add(expression);
		}
		if(listExpression != null && !listExpression.isSelected()){
			edge.getExpressions().remove(expression);
		}
	}
	
	

}
