package org.processmining.processtree.visualization.originator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;

import org.processmining.framework.util.Pair;
import org.processmining.processtree.Originator;
import org.processmining.processtree.Task.Manual;

public class OriginatorApplyActionListener implements ActionListener{
	Map<Pair<Manual, Originator>, OriginatorCell> originatorCells;
	
	public OriginatorApplyActionListener(Map<Pair<Manual, Originator>, OriginatorCell> originatorCells){
		this.originatorCells = originatorCells;
	}
	
	public void actionPerformed(ActionEvent e) {
		// when we have clicked on apply we have to serialise all the choices to the tasks and variables
		// note: we have a total mapping so we can just check all combinations
		for(Pair<Manual, Originator> orgCell : originatorCells.keySet()){
			Manual man = orgCell.getFirst();
			Originator org = orgCell.getSecond();
			man.getOriginators().remove(org);
			man.getRemovableOriginators().remove(org);
			// now add them again accordingly
			if(originatorCells.get(orgCell).getExecutes().isSelected()){
				man.getOriginators().add(org);
			}
			if(originatorCells.get(orgCell).getRemExecutes().isSelected()){
				man.getRemovableOriginators().add(org);
			}
			
		}
	}

}
