package org.processmining.projectedrecallandprecision.framework;

import java.util.Set;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.framework.plugin.ProMCanceller;
import org.processmining.plugins.InductiveMiner.efficienttree.EfficientTreeReduce.ReductionFailedException;
import org.processmining.projectedrecallandprecision.helperclasses.AcceptingPetriNetProject;
import org.processmining.projectedrecallandprecision.helperclasses.AutomatonFailedException;
import org.processmining.projectedrecallandprecision.helperclasses.automata.DFA;

public class ComparePetriNet2PetriNet extends ModelModelFramework<AcceptingPetriNet, AcceptingPetriNet> {
	@Override
	public Set<String> getActivitiesSystem(AcceptingPetriNet system) {
		return AcceptingPetriNetProject.getActivitiesPetriNet(system.getNet());
	}

	@Override
	public Set<String> getActivitiesModel(AcceptingPetriNet model) {
		return AcceptingPetriNetProject.getActivitiesPetriNet(model.getNet());
	}

	@Override
	public DFA projectAndAutomatiseSystem(AcceptingPetriNet system, CompareParameters parameters,
			ProMCanceller canceller, String... names) throws AutomatonFailedException {
		return AcceptingPetriNetProject.projectAndAutomatisePetrinet(system, parameters, canceller, names);
	}

	@Override
	public DFA projectAndAutomatiseModel(AcceptingPetriNet model, CompareParameters parameters,
			ProMCanceller canceller, String... names) throws ReductionFailedException, AutomatonFailedException {
		return AcceptingPetriNetProject.projectAndAutomatisePetrinet(model, parameters, canceller, names);
	}
}
