package org.processmining.projectedrecallandprecision.framework;

import java.util.Arrays;
import java.util.Set;

import org.processmining.framework.plugin.ProMCanceller;
import org.processmining.plugins.InductiveMiner.efficienttree.EfficientTree;
import org.processmining.plugins.InductiveMiner.efficienttree.EfficientTreeReduce.ReductionFailedException;
import org.processmining.plugins.InductiveMiner.efficienttree.UnknownTreeNodeException;
import org.processmining.projectedrecallandprecision.helperclasses.EfficientTreeProject;
import org.processmining.projectedrecallandprecision.helperclasses.automata.DFA;

import gnu.trove.set.hash.THashSet;

public class CompareProcessTree2ProcessTree extends ModelModelFramework<EfficientTree, EfficientTree> {

	@Override
	public Set<String> getActivitiesSystem(EfficientTree system) {
		return new THashSet<>(Arrays.asList(system.getInt2activity()));
	}

	@Override
	public Set<String> getActivitiesModel(EfficientTree model) {
		return new THashSet<>(Arrays.asList(model.getInt2activity()));
	}

	@Override
	public DFA projectAndAutomatiseSystem(EfficientTree system, CompareParameters parameters,
			ProMCanceller canceller, String... names)
			throws InterruptedException, ReductionFailedException, UnknownTreeNodeException, CloneNotSupportedException {
		return EfficientTreeProject.projectAndAutomatiseTree(system, parameters, canceller, names);
	}

	@Override
	public DFA projectAndAutomatiseModel(EfficientTree model, CompareParameters parameters,
			ProMCanceller canceller, String... names)
			throws ReductionFailedException, UnknownTreeNodeException, CloneNotSupportedException {
		return EfficientTreeProject.projectAndAutomatiseTree(model, parameters, canceller, names);
	}

}
