package org.processmining.projectedrecallandprecision.helperclasses.automata;

import static org.processmining.projectedrecallandprecision.helperclasses.automata.testAutomaton.check;

import java.util.Arrays;

import org.processmining.projectedrecallandprecision.helperclasses.automata.operations.StatePairSet;

public class testStatePairSet {

	public static void test() throws Exception {
		System.out.println("test state pair");

		//test simple model
		{
			int[] statePairSet = StatePairSet.create(1, 2);
			statePairSet = StatePairSet.add(statePairSet, 0, 1);
			statePairSet = StatePairSet.add(statePairSet, 1, 1);

			check(Arrays.equals(statePairSet, new int[] { 0, 1, 1, 1, 1, 2 }), "order");
		}

		{
			int[] statePairSet = StatePairSet.create(1, 1);
			statePairSet = StatePairSet.add(statePairSet, 3, 0);

			check(Arrays.equals(statePairSet, new int[] { 1, 1, 3, 0 }), "order");
		}
		
		{
			int[] statePairSet = StatePairSet.create(1, 1);
			statePairSet = StatePairSet.add(statePairSet, 0, 1);
			statePairSet = StatePairSet.add(statePairSet, 0, 0);

			check(Arrays.equals(statePairSet, new int[] { 0, 0, 0, 1, 1, 1 }), "order");
		}

	}
}
